:root {
  --gmfx-soundcard-width: 10rem;
  --gmfx-soundcard-height: 8rem;
  --gmfx-soundcard-padding: 10px;
  --gmfx-soundcard-border-width: 3px;
  --gmfx-soundcard-controls-width: clamp(0px, 2rem, 2rem);
}

.soundboard-container {
  width: clamp(200px, 100%, 1610px);

  display: flex;
  flex-direction: column;
  align-items: center;
}

.soundboard {
  min-height: 70vh;
}

.soundboard-desktop-message {
  display: block;
}

.soundboard-mobile-message {
  display: none;
}

.soundboard-safari-message {
  display: none;
}

.soundboard-lane {
  position: relative;

  font-family: var(--bardic-font-sans);

  background-repeat: no-repeat;
  background-position: center;
  background-size: cover;
  background-color: var(--bardic-dark-80a);
  background-blend-mode: multiply;

  background-image: url("/public/img/hero-bg-lines.png");

  border: 2px solid var(--pico-muted-border-color);

  --pico-accordion-active-summary-color: var(--bardic-light);
  --pico-accordion-open-summary-color: var(--bardic-light);
  --pico-accordion-close-summary-color: var(--bardic-light);

  details summary {
    background-color: transparent;
    border: 0;
    text-shadow:
      0 0 1rem var(--bardic-dark),
      0 0 0.5rem var(--bardic-dark),
      0 0 0.3rem var(--bardic-dark);
    transition: all var(--pico-transition);
  }
}

.soundboard-lane-header {
  display: grid;
  gap: 1rem;
  grid-template-areas: "title controls open";
  grid-template-columns: auto fit-content(10rem) 1.5rem;
  align-items: center;

  background-color: var(--bardic-light);

  border: 1px solid;
  border-width: 1px;

  height: auto;
}

.soundboard-lane-container {
  display: flex;
  flex-wrap: wrap;

  gap: 10px;
  padding: 10px;

  background-color: var(--bardic-light-90a);

  border: 3px solid;
  border-color: var(--bardic-blue);
  border-radius: var(--pico-border-radius);
}

.soundboard-lane-title-container {
  grid-area: title;
  display: grid;
  gap: 0.5rem;
  grid-template-columns: fit-content(70%) 1rem 1rem 1rem 1rem 1rem 1rem;
  align-items: center;
  font-size: 2rem;
  line-height: 2rem;

  .scene-title {
    display: flex;
    gap: 0.5rem;

    svg {
      width: 2rem;
    }
  }
}

@media screen and (width <600px) {
  .soundboard-lane-title-container {
    font-size: 1.5rem;
    line-height: 1.5rem;
  }

  .soundboard-desktop-message {
    display: none;
  }

  .soundboard-mobile-message {
    display: block;
  }

  .soundboard-safari-message {
    display: none;
  }

  .soundboard-lane {
    padding: 5px;
  }

  .soundboard-lane-container {

    /* On mobile, make every element take 100% of the row */
    >* {
      flex: 0 0 100%;
    }
  }
}

@supports (-webkit-hyphens: none) {
  .soundboard-desktop-message {
    display: none;
  }

  .soundboard-mobile-message {
    display: none;
  }

  .soundboard-safari-message {
    display: block;
  }
}

.soundboard-lane-title-input {
  padding: 2px;
  --pico-spacing: 0px;
  line-height: 1rem;
  --pico-form-element-spacing-vertical: 0px;
  --pico-form-element-spacing-horizontal: 5px;
}

.soundboard-sound-title-input {
  padding: 2px;
  font-size: 0.875em;
  --pico-spacing: 0px;
  line-height: 1rem;
  --pico-form-element-spacing-vertical: 0px;
  --pico-form-element-spacing-horizontal: 5px;
}

.soundcard-credits {
  position: absolute;
  top: 100%;
  left: 5px;
  transform: translate(0%, -100%);

  small {
    font-size: x-small;
  }
}

.upload-progress {
  --pico-progress-background-color: var(--bardic-dark);
  --pico-progress-color: var(--bardic-blue);
}

.ambience-header {
  display: grid;
  grid-template-columns: auto fit-content(20rem);
  gap: 1rem;

  align-items: end;

  button {
    padding: var(--gmfx-soundcard-padding);
    display: flex;
    gap: var(--gmfx-soundcard-padding);
    align-items: center;
    justify-content: center;
  }
}

.add-scene-container {
  display: grid;
  gap: 1rem;
  grid-template-columns: auto;
}

.scene-global-controls {
  grid-area: controls;
  display: grid;
  align-items: center;
  justify-content: center;
  height: 2rem;

  grid-template-areas: "presets volume settings play";
  grid-template-columns: fit-content(10rem) 10rem auto fit-content(7rem);
  grid-template-rows: 2rem;

  gap: var(--gmfx-soundcard-padding);

  .control-button {
    display: grid;
    align-items: center;
    height: 2rem;
    padding-left: var(--gmfx-soundcard-padding);
    padding-right: var(--gmfx-soundcard-padding);

    border: 2px solid var(--bardic-blue);
    border-radius: var(--pico-border-radius);

    background-color: var(--bardic-dark);

    font-size: large;

    svg {
      width: 1rem;
      height: 1rem;
    }
  }

  .scene-presets {
    grid-area: presets;

    display: flex;
    flex-direction: row-reverse;
    gap: 5px;
  }

  .scene-settings {
    grid-area: settings;
  }

  .scene-volume {
    grid-area: volume;
  }

  .scene-play-button {
    grid-area: play;
    display: grid;
    align-items: center;
    justify-items: center;
    grid-template-columns: auto 1.5rem;
    width: 7rem;
    white-space: nowrap;
    gap: var(--gmfx-soundcard-padding);
  }
}

/* This has to be applied to a container holding the input, not the input itself. */
.scene-volume-controls {
  display: flex;
  flex-direction: row;
  align-items: center;
  gap: 3px;

  margin: 0;

  --pico-spacing: 0;
  --pico-range-thumb-color: var(--bardic-dark);
  --pico-range-thumb-border-color: var(--bardic-light);
  --pico-range-border-color: var(--bardic-light);
  --pico-range-active-border-color: var(--bardic-light);

  input[type="range"] {
    appearance: none;
    margin-bottom: 0;
  }

  /******** Chrome and Safari ********/
  input[type="range"]::-webkit-slider-thumb {
    height: 1rem;
    width: 1rem;
  }

  input[type="range"]::-webkit-slider-runnable-track {
    height: 0.2rem;
  }

  /******** Firefox ********/
  input[type="range"]::-moz-range-track {
    height: 0.2rem;
  }

  input[type="range"]::-moz-range-thumb {
    height: 0.6rem;
    width: 0.6rem;
  }

  input[type="range"]:focus-within {
    --pico-range-border-color: var(--bardic-light);
    --pico-range-active-border-color: var(--bardic-light);
  }

  svg {
    /* We set the height in px because we always want them to be small, no mater the font size */
    height: 20px;
  }
}

.guided-scene-music-header {
  display: flex;
  justify-content: space-between;

  .playlist-controls {
    display: flex;
    gap: 1rem;
  }
}

.settings-list {
  display: grid;
  gap: 1rem;

  .setting-title {
    display: flex;
    gap: 0.5rem;

    svg {
      height: 1.5rem;
      /* The subtraction is to account for the extra height */
      margin-bottom: calc(var(--pico-typography-spacing-vertical) - 0.5rem);
    }
  }

  .settings-toggle {
    display: grid;
    grid-template-areas:
      "checkbox title"
      "description description";

    grid-template-columns: fit-content(3rem) auto;

    input {
      grid-area: checkbox;
      border: 2px solid var(--bardic-blue);
      --pico-box-shadow: 0;
    }

    b {
      grid-area: title;
    }

    span {
      grid-area: description;
      font-size: 75%;
    }
  }
}

@media screen and (width <900px) {
  .soundboard-lane-header {
    grid-template-areas: "title title" "controls open";
    grid-template-columns: auto 1.5rem;
    height: 8rem;
    gap: 0;
  }

  .scene-global-controls {
    grid-template-areas: "volume settings play" "presets presets presets";
    justify-content: left;
    grid-template-columns: 8rem auto fit-content(10rem);
    gap: 5px;

    height: 4rem;

    .scene-play-button {
      width: fit-content;
    }

    .scene-presets {
      flex-direction: row;
    }
  }
}

@media screen and (width <600px) {
  .scene-global-controls {
    justify-content: left;

    grid-template-areas: "volume settings play" "presets presets presets";
    grid-template-columns: 5rem auto fit-content(7rem);

    .scene-play-button {
      width: 6rem;
      font-size: small;
      gap: 1px;
    }

    .scene-presets {
      flex-direction: row;
    }
  }
}